#include "stdafx.h"
#include "testtfileview.h"
#include "testtfileviewDoc.h"
#include "testtfileviewView.h"
#include "FilenameMaskDlg.h"
#include "RootFolderDlg.h"
#include "SelectedPathDlg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif //#ifdef _DEBUG

#ifndef TVS_EX_DOUBLEBUFFER
#define TVS_EX_DOUBLEBUFFER 0x0004
#endif //#ifndef TVS_EX_DOUBLEBUFFER

#ifndef TVS_EX_AUTOHSCROLL
#define TVS_EX_AUTOHSCROLL 0x0020
#endif //#ifndef TVS_EX_AUTOHSCROLL

#ifndef TVS_EX_FADEINOUTEXPANDOS
#define TVS_EX_FADEINOUTEXPANDOS 0x0040
#endif //#ifndef TVS_EX_FADEINOUTEXPANDOS

#ifndef TVM_SETEXTENDEDSTYLE
#define TVM_SETEXTENDEDSTYLE (TV_FIRST + 44)
#endif //#ifndef TVM_SETEXTENDEDSTYLE


void CMyTreeFileCtrl::OnSelectionChanged(_In_ NM_TREEVIEW* /*pTreeView*/, _In_ const CString& sPath)
{
  //For demonstration purposes, we will change the document title
#pragma warning(suppress: 26466)
  auto pParent = static_cast<CTesttfileviewView*>(GetParent());
#pragma warning(suppress: 26496)
  AFXASSUME(pParent != nullptr);
  pParent->GetDocument()->SetTitle(sPath);
}

#pragma warning(suppress: 26409 26440 26433 26477)
IMPLEMENT_DYNCREATE(CTesttfileviewView, CView)

#pragma warning(suppress: 26433 26440)
BEGIN_MESSAGE_MAP(CTesttfileviewView, CView) //NOLINT(modernize-avoid-c-arrays)
  ON_WM_CREATE()
  ON_WM_SIZE()
  ON_WM_SETFOCUS()
  ON_COMMAND(ID_TOOLS_ALLOWCREATEFOLDER, &CTesttfileviewView::OnToolsAllowCreateFolder)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_ALLOWCREATEFOLDER, &CTesttfileviewView::OnUpdateToolsAllowCreateFolder)
  ON_COMMAND(ID_TOOLS_ALLOWDELETE, &CTesttfileviewView::OnToolsAllowDelete)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_ALLOWDELETE, &CTesttfileviewView::OnUpdateToolsAllowDelete)
  ON_COMMAND(ID_TOOLS_ALLOWOPEN, &CTesttfileviewView::OnToolsAllowOpen)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_ALLOWOPEN, &CTesttfileviewView::OnUpdateToolsAllowOpen)
  ON_COMMAND(ID_TOOLS_ALLOWRENAME, &CTesttfileviewView::OnToolsAllowRename)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_ALLOWRENAME, &CTesttfileviewView::OnUpdateToolsAllowRename)
  ON_COMMAND(ID_TOOLS_ALLOWPROPERTIES, &CTesttfileviewView::OnToolsAllowProperties)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_ALLOWPROPERTIES, &CTesttfileviewView::OnUpdateToolsAllowProperties)
  ON_COMMAND(ID_TOOLS_SHOWFILES, &CTesttfileviewView::OnToolsShowFiles)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_SHOWFILES, &CTesttfileviewView::OnUpdateToolsShowFiles)
  ON_COMMAND(ID_TOOLS_ALLOWDRAGDROP, &CTesttfileviewView::OnToolsAllowDragDrop)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_ALLOWDRAGDROP, &CTesttfileviewView::OnUpdateToolsAllowDragDrop)
  ON_COMMAND(ID_TOOLS_HIDECDROM, &CTesttfileviewView::OnToolsHideCDROM)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDECDROM, &CTesttfileviewView::OnUpdateToolsHideCDROM)
  ON_COMMAND(ID_TOOLS_HIDEFIXED, &CTesttfileviewView::OnToolsHideFixed)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDEFIXED, &CTesttfileviewView::OnUpdateToolsHideFixed)
  ON_COMMAND(ID_TOOLS_HIDERAMDISKS, &CTesttfileviewView::OnToolsHideRAMDisks)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDERAMDISKS, &CTesttfileviewView::OnUpdateToolsHideRAMDisks)
  ON_COMMAND(ID_TOOLS_HIDEREMOVABLE, &CTesttfileviewView::OnToolsHideRemovable)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDEREMOVABLE, &CTesttfileviewView::OnUpdateToolsHideRemovable)
  ON_COMMAND(ID_TOOLS_HIDEREMOTE, &CTesttfileviewView::OnToolsHideRemote)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDEREMOTE, &CTesttfileviewView::OnUpdateToolsHideRemote)
  ON_COMMAND(ID_TOOLS_FILENAMEMASK, &CTesttfileviewView::OnToolsFileNameMask)
  ON_COMMAND(ID_TOOLS_HIDEHIDDEN, &CTesttfileviewView::OnToolsHideHidden)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDEHIDDEN, &CTesttfileviewView::OnUpdateToolsHideHidden)
  ON_COMMAND(ID_TOOLS_HIDEARCHIVE, &CTesttfileviewView::OnToolsHideArchive)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDEARCHIVE, &CTesttfileviewView::OnUpdateToolsHideArchive)
  ON_COMMAND(ID_TOOLS_HIDECOMPRESSED, &CTesttfileviewView::OnToolsHideCompressed)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDECOMPRESSED, &CTesttfileviewView::OnUpdateToolsHideCompressed)
  ON_COMMAND(ID_TOOLS_HIDESYSTEM, &CTesttfileviewView::OnToolsHideSystem)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDESYSTEM, &CTesttfileviewView::OnUpdateToolsHideSystem)
  ON_COMMAND(ID_TOOLS_HIDETEMPORARY, &CTesttfileviewView::OnToolsHideTemporary)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDETEMPORARY, &CTesttfileviewView::OnUpdateToolsHideTemporary)
  ON_COMMAND(ID_TOOLS_HIDEENCRYPTED, &CTesttfileviewView::OnToolsHideEncrypted)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDEENCRYPTED, &CTesttfileviewView::OnUpdateToolsHideEncrypted)
  ON_COMMAND(ID_TOOLS_HIDEOFFLINE, &CTesttfileviewView::OnToolsHideOffline)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDEOFFLINE, &CTesttfileviewView::OnUpdateToolsHideOffline)
  ON_COMMAND(ID_TOOLS_HIDEREADONLY, &CTesttfileviewView::OnToolsHideReadOnly)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDEREADONLY, &CTesttfileviewView::OnUpdateToolsHideReadOnly)
  ON_COMMAND(ID_TOOLS_HIDEREPARSEPOINT, &CTesttfileviewView::OnToolsHideReparsePoint)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDEREPARSEPOINT, &CTesttfileviewView::OnUpdateToolsHideReparsePoint)
  ON_COMMAND(ID_TOOLS_HIDESPARSE, &CTesttfileviewView::OnToolsHideSparse)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDESPARSE, &CTesttfileviewView::OnUpdateToolsHideSparse)
  ON_COMMAND(ID_TOOLS_HIDEHIDDEN2, &CTesttfileviewView::OnToolsHideHidden2)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDEHIDDEN2, &CTesttfileviewView::OnUpdateToolsHideHidden2)
  ON_COMMAND(ID_TOOLS_HIDEARCHIVE2, &CTesttfileviewView::OnToolsHideArchive2)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDEARCHIVE2, &CTesttfileviewView::OnUpdateToolsHideArchive2)
  ON_COMMAND(ID_TOOLS_HIDECOMPRESSED2, &CTesttfileviewView::OnToolsHideCompressed2)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDECOMPRESSED2, &CTesttfileviewView::OnUpdateToolsHideCompressed2)
  ON_COMMAND(ID_TOOLS_HIDESYSTEM2, &CTesttfileviewView::OnToolsHideSystem2)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDESYSTEM2, &CTesttfileviewView::OnUpdateToolsHideSystem2)
  ON_COMMAND(ID_TOOLS_HIDETEMPORARY2, &CTesttfileviewView::OnToolsHideTemporary2)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDETEMPORARY2, &CTesttfileviewView::OnUpdateToolsHideTemporary2)
  ON_COMMAND(ID_TOOLS_HIDEENCRYPTED2, &CTesttfileviewView::OnToolsHideEncrypted2)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDEENCRYPTED2, &CTesttfileviewView::OnUpdateToolsHideEncrypted2)
  ON_COMMAND(ID_TOOLS_HIDEOFFLINE2, &CTesttfileviewView::OnToolsHideOffline2)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDEOFFLINE2, &CTesttfileviewView::OnUpdateToolsHideOffline2)
  ON_COMMAND(ID_TOOLS_HIDEREADONLY2, &CTesttfileviewView::OnToolsHideReadOnly2)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDEREADONLY2, &CTesttfileviewView::OnUpdateToolsHideReadOnly2)
  ON_COMMAND(ID_TOOLS_HIDEREPARSEPOINT2, &CTesttfileviewView::OnToolsHideReparsePoint2)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDEREPARSEPOINT2, &CTesttfileviewView::OnUpdateToolsHideReparsePoint2)
  ON_COMMAND(ID_TOOLS_HIDESPARSE2, &CTesttfileviewView::OnToolsHideSparse2)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDESPARSE2, &CTesttfileviewView::OnUpdateToolsHideSparse2)
  ON_COMMAND(ID_TOOLS_AUTOREFRESH, &CTesttfileviewView::OnToolsAutoRefresh)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_AUTOREFRESH, &CTesttfileviewView::OnUpdateToolsAutoRefresh)
  ON_COMMAND(ID_TOOLS_SETROOTFOLDER, &CTesttfileviewView::OnToolsSetRootFolder)
  ON_WM_DESTROY()
  ON_COMMAND(ID_TOOLS_HIDENETWORK, &CTesttfileviewView::OnToolsHideNetwork)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDENETWORK, &CTesttfileviewView::OnUpdateToolsHideNetwork)
  ON_COMMAND(ID_TOOLS_SHOWSHAREDFOLDERS, &CTesttfileviewView::OnToolsShowSharedFolders)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_SHOWSHAREDFOLDERS, &CTesttfileviewView::OnUpdateToolsShowSharedFolders)
  ON_COMMAND(ID_TOOLS_SHOWALLNETWORKITEMS, &CTesttfileviewView::OnToolsShowAllNetworkItems)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_SHOWALLNETWORKITEMS, &CTesttfileviewView::OnUpdateToolsShowAllNetworkItems)
  ON_COMMAND(ID_TOOLS_SHOWNETWORKPRINTERS, &CTesttfileviewView::OnToolsShowNetworkPrinters)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_SHOWNETWORKPRINTERS, &CTesttfileviewView::OnUpdateToolsShowNetworkPrinters)
  ON_COMMAND(ID_TOOLS_SHOWNETWORKSHARES, &CTesttfileviewView::OnToolsShowNetworkShares)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_SHOWNETWORKSHARES, &CTesttfileviewView::OnUpdateToolsShowNetworkShares)
  ON_COMMAND(ID_TOOLS_SHOWDRIVELABELS, &CTesttfileviewView::OnToolsShowDriveLabels)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_SHOWDRIVELABELS, &CTesttfileviewView::OnUpdateToolsShowDriveLabels)
  ON_COMMAND(ID_TOOLS_HIDEMYCOMPUTER, &CTesttfileviewView::OnToolsHideMyComputer)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDEMYCOMPUTER, &CTesttfileviewView::OnUpdateToolsHideMyComputer)
  ON_COMMAND(ID_TOOLS_SHOWROOTEDFOLDER, &CTesttfileviewView::OnToolsShowRootedFolder)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_SHOWROOTEDFOLDER, &CTesttfileviewView::OnUpdateToolsShowRootedFolder)
  ON_COMMAND(ID_TOOLS_SETSELECTEDPATH, &CTesttfileviewView::OnToolsSetSelectedPath)
  ON_COMMAND(ID_TOOLS_HIDEDESKTOP, &CTesttfileviewView::OnToolsHideDesktop)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDEDESKTOP, &CTesttfileviewView::OnUpdateToolsHideDesktop)
  ON_COMMAND(ID_TOOLS_HIDEMYDOCUMENTS, &CTesttfileviewView::OnToolsHideMyDocuments)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDEMYDOCUMENTS, &CTesttfileviewView::OnUpdateToolsHideMyDocuments)
  ON_COMMAND(ID_TOOLS_HIDECURRENTUSERFOLDER, &CTesttfileviewView::OnToolsHideCurrentUserFolder)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDECURRENTUSERFOLDER, &CTesttfileviewView::OnUpdateToolsHideCurrentUserFolder)
  ON_COMMAND(ID_FILE_PRINT, &CView::OnFilePrint)
  ON_COMMAND(ID_FILE_PRINT_DIRECT, &CView::OnFilePrint)
  ON_COMMAND(ID_FILE_PRINT_PREVIEW, &CView::OnFilePrintPreview)
END_MESSAGE_MAP()

CTesttfileviewView::CTesttfileviewView() noexcept //NOLINT(modernize-use-equals-default)
{
}

BOOL CTesttfileviewView::PreCreateWindow(CREATESTRUCT& cs)
{
  //Let the base class do its thing
  return __super::PreCreateWindow(cs);
}

void CTesttfileviewView::OnDraw(CDC* /*pDC*/) noexcept
{
}

BOOL CTesttfileviewView::OnPreparePrinting(CPrintInfo* pInfo)
{
  return DoPreparePrinting(pInfo);
}

void CTesttfileviewView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/) noexcept
{
}

void CTesttfileviewView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/) noexcept
{
}

#ifdef _DEBUG
void CTesttfileviewView::AssertValid() const
{
  //Let the base class do its thing
  __super::AssertValid();
}

void CTesttfileviewView::Dump(CDumpContext& dc) const
{
  //Let the base class do its thing
  __super::Dump(dc);
}
#endif //#ifdef _DEBUG

#pragma warning(suppress: 26434 26440)
CTesttfileviewDoc* CTesttfileviewView::GetDocument()
{
  ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CTesttfileviewDoc)));
#pragma warning(suppress: 26466)
  return static_cast<CTesttfileviewDoc*>(m_pDocument);
}

#pragma warning(suppress: 26434)
int CTesttfileviewView::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
  //Let the base class do its thing
  if (__super::OnCreate(lpCreateStruct) == -1)
    return -1;

  //Create the tree view
  const CRect r;
  if (!m_TreeFile.Create(WS_VISIBLE | WS_CHILD | WS_TABSTOP | TVS_HASBUTTONS | TVS_EDITLABELS | TVS_NOHSCROLL | TVS_SHOWSELALWAYS, r, this, 100))
    return -1;

  //Turn on the vista explorer theme if necessary
  SetWindowTheme(m_TreeFile.GetSafeHwnd(), L"explorer", nullptr);

  //Turn on the various Vista style extended styles
  m_TreeFile.SendMessage(TVM_SETEXTENDEDSTYLE, 0, TVS_EX_AUTOHSCROLL | TVS_EX_DOUBLEBUFFER | TVS_EX_FADEINOUTEXPANDOS);

  return 0;
}

#pragma warning(suppress: 26434)
void CTesttfileviewView::OnSize(UINT nType, int cx, int cy)
{
  //Let the parent class do its thing
  __super::OnSize(nType, cx, cy);

  //Let the tree control occupy all the space of the client area
  CRect rClient;  
  GetClientRect(&rClient);
  m_TreeFile.MoveWindow(rClient);
}

#pragma warning(suppress: 26434)
void CTesttfileviewView::OnSetFocus(CWnd* pOldWnd)
{
  //Let the parent class do its thing
  __super::OnSetFocus(pOldWnd);
  
  //Ensure the tree view control gets the focus when the view gets the focus 
  m_TreeFile.SetFocus();
}

void CTesttfileviewView::OnToolsAllowDelete() noexcept
{
  m_TreeFile.SetAllowDelete(!m_TreeFile.GetAllowDelete());
}

#pragma warning(suppress: 26429)
void CTesttfileviewView::OnUpdateToolsAllowDelete(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeFile.GetAllowDelete());
}

void CTesttfileviewView::OnToolsAllowOpen() noexcept
{
  m_TreeFile.SetAllowOpen(!m_TreeFile.GetAllowOpen());
}

#pragma warning(suppress: 26429)
void CTesttfileviewView::OnUpdateToolsAllowOpen(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeFile.GetAllowOpen());
}

void CTesttfileviewView::OnToolsAllowRename() noexcept
{
  m_TreeFile.SetAllowRename(!m_TreeFile.GetAllowRename());
}

#pragma warning(suppress: 26429)
void CTesttfileviewView::OnUpdateToolsAllowRename(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeFile.GetAllowRename());
}

void CTesttfileviewView::OnToolsAllowProperties() noexcept
{
  m_TreeFile.SetAllowProperties(!m_TreeFile.GetAllowProperties());
}

#pragma warning(suppress: 26429)
void CTesttfileviewView::OnUpdateToolsAllowProperties(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeFile.GetAllowProperties());
}

void CTesttfileviewView::OnToolsShowFiles()
{
  m_TreeFile.SetShowFiles(!m_TreeFile.GetShowFiles());
}

#pragma warning(suppress: 26429)
void CTesttfileviewView::OnUpdateToolsShowFiles(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeFile.GetShowFiles());
}

void CTesttfileviewView::OnToolsAllowCreateFolder() noexcept
{
  m_TreeFile.SetAllowCreateFolder(!m_TreeFile.GetAllowCreateFolder());
}

#pragma warning(suppress: 26429)
void CTesttfileviewView::OnUpdateToolsAllowCreateFolder(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeFile.GetAllowCreateFolder());
}

void CTesttfileviewView::OnInitialUpdate()
{
  //Let the parent class do its thing
  __super::OnInitialUpdate();

  //Set the selected path in the tree control	
  m_TreeFile.PopulateTree();
  CWinApp* pApp = AfxGetApp();
#pragma warning(suppress: 26496)
  AFXASSUME(pApp != nullptr);
  CString sSelPath = pApp->GetProfileString(_T("Settings"), _T("Last Path"), _T("C:\\"));
  const BOOL bExpanded = pApp->GetProfileInt(_T("Settings"), _T("Expanded"), FALSE);
  m_TreeFile.SetSelectedPath(sSelPath, bExpanded);
}

void CTesttfileviewView::OnToolsAllowDragDrop() noexcept
{
  m_TreeFile.SetAllowDragDrop(!m_TreeFile.GetAllowDragDrop());
}

#pragma warning(suppress: 26429)
void CTesttfileviewView::OnUpdateToolsAllowDragDrop(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeFile.GetAllowDragDrop());
}

BOOL CTesttfileviewView::OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo)
{
  //Give the control first crack
  if (m_TreeFile.OnCmdMsg(nID, nCode, pExtra, pHandlerInfo))
    return TRUE;	
  return __super::OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
}

void CTesttfileviewView::OnToolsHideCDROM()
{
  if (m_TreeFile.GetDriveHideFlags() & CFileTreeCtrl::DriveType::DRIVE_ATTRIBUTE_CDROM)
    m_TreeFile.SetDriveHideFlags(m_TreeFile.GetDriveHideFlags() & ~CFileTreeCtrl::DriveType::DRIVE_ATTRIBUTE_CDROM);
  else
    m_TreeFile.SetDriveHideFlags(m_TreeFile.GetDriveHideFlags() | CFileTreeCtrl::DriveType::DRIVE_ATTRIBUTE_CDROM);
}

#pragma warning(suppress: 26429)
void CTesttfileviewView::OnUpdateToolsHideCDROM(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeFile.GetDriveHideFlags() & CFileTreeCtrl::DriveType::DRIVE_ATTRIBUTE_CDROM);
}

void CTesttfileviewView::OnToolsHideFixed()
{
  if (m_TreeFile.GetDriveHideFlags() & CFileTreeCtrl::DriveType::DRIVE_ATTRIBUTE_FIXED)
    m_TreeFile.SetDriveHideFlags(m_TreeFile.GetDriveHideFlags() & ~CFileTreeCtrl::DriveType::DRIVE_ATTRIBUTE_FIXED);
  else
    m_TreeFile.SetDriveHideFlags(m_TreeFile.GetDriveHideFlags() | CFileTreeCtrl::DriveType::DRIVE_ATTRIBUTE_FIXED);
}

#pragma warning(suppress: 26429)
void CTesttfileviewView::OnUpdateToolsHideFixed(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeFile.GetDriveHideFlags() & CFileTreeCtrl::DriveType::DRIVE_ATTRIBUTE_FIXED);
}

void CTesttfileviewView::OnToolsHideRAMDisks()
{
  if (m_TreeFile.GetDriveHideFlags() & CFileTreeCtrl::DriveType::DRIVE_ATTRIBUTE_RAMDISK)
    m_TreeFile.SetDriveHideFlags(m_TreeFile.GetDriveHideFlags() & ~CFileTreeCtrl::DriveType::DRIVE_ATTRIBUTE_RAMDISK);
  else
    m_TreeFile.SetDriveHideFlags(m_TreeFile.GetDriveHideFlags() | CFileTreeCtrl::DriveType::DRIVE_ATTRIBUTE_RAMDISK);
}

#pragma warning(suppress: 26429)
void CTesttfileviewView::OnUpdateToolsHideRAMDisks(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeFile.GetDriveHideFlags() & CFileTreeCtrl::DriveType::DRIVE_ATTRIBUTE_RAMDISK);
}

void CTesttfileviewView::OnToolsHideRemovable()
{
  if (m_TreeFile.GetDriveHideFlags() & CFileTreeCtrl::DriveType::DRIVE_ATTRIBUTE_REMOVABLE)
    m_TreeFile.SetDriveHideFlags(m_TreeFile.GetDriveHideFlags() & ~CFileTreeCtrl::DriveType::DRIVE_ATTRIBUTE_REMOVABLE);
  else
    m_TreeFile.SetDriveHideFlags(m_TreeFile.GetDriveHideFlags() | CFileTreeCtrl::DriveType::DRIVE_ATTRIBUTE_REMOVABLE);
}

#pragma warning(suppress: 26429)
void CTesttfileviewView::OnUpdateToolsHideRemovable(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeFile.GetDriveHideFlags() & CFileTreeCtrl::DriveType::DRIVE_ATTRIBUTE_REMOVABLE);
}

void CTesttfileviewView::OnToolsHideRemote()
{
  if (m_TreeFile.GetDriveHideFlags() & CFileTreeCtrl::DriveType::DRIVE_ATTRIBUTE_REMOTE)
    m_TreeFile.SetDriveHideFlags(m_TreeFile.GetDriveHideFlags() & ~CFileTreeCtrl::DriveType::DRIVE_ATTRIBUTE_REMOTE);
  else
    m_TreeFile.SetDriveHideFlags(m_TreeFile.GetDriveHideFlags() | CFileTreeCtrl::DriveType::DRIVE_ATTRIBUTE_REMOTE);
}

#pragma warning(suppress: 26429)
void CTesttfileviewView::OnUpdateToolsHideRemote(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeFile.GetDriveHideFlags() & CFileTreeCtrl::DriveType::DRIVE_ATTRIBUTE_REMOTE);
}

void CTesttfileviewView::OnToolsFileNameMask()
{
  CFilenameMaskDlg dlg;
  dlg.m_sMask = m_TreeFile.GetFileNameMasks();
  if (dlg.DoModal() == IDOK)
    m_TreeFile.AddMultipleFileNameMasks(dlg.m_sMask);
}

void CTesttfileviewView::OnToolsHideHidden()
{
  if (m_TreeFile.GetFileHideFlags() & FILE_ATTRIBUTE_HIDDEN)
    m_TreeFile.SetFileHideFlags(m_TreeFile.GetFileHideFlags() & ~FILE_ATTRIBUTE_HIDDEN);
  else
    m_TreeFile.SetFileHideFlags(m_TreeFile.GetFileHideFlags() | FILE_ATTRIBUTE_HIDDEN);
}

#pragma warning(suppress: 26429)
void CTesttfileviewView::OnUpdateToolsHideHidden(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeFile.GetFileHideFlags() & FILE_ATTRIBUTE_HIDDEN);
}

void CTesttfileviewView::OnToolsHideArchive()
{
  if (m_TreeFile.GetFileHideFlags() & FILE_ATTRIBUTE_ARCHIVE)
    m_TreeFile.SetFileHideFlags(m_TreeFile.GetFileHideFlags() & ~FILE_ATTRIBUTE_ARCHIVE);
  else
    m_TreeFile.SetFileHideFlags(m_TreeFile.GetFileHideFlags() | FILE_ATTRIBUTE_ARCHIVE);
}

#pragma warning(suppress: 26429)
void CTesttfileviewView::OnUpdateToolsHideArchive(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeFile.GetFileHideFlags() & FILE_ATTRIBUTE_ARCHIVE);
}

void CTesttfileviewView::OnToolsHideCompressed()
{
  if (m_TreeFile.GetFileHideFlags() & FILE_ATTRIBUTE_COMPRESSED)
    m_TreeFile.SetFileHideFlags(m_TreeFile.GetFileHideFlags() & ~FILE_ATTRIBUTE_COMPRESSED);
  else
    m_TreeFile.SetFileHideFlags(m_TreeFile.GetFileHideFlags() | FILE_ATTRIBUTE_COMPRESSED);
}

#pragma warning(suppress: 26429)
void CTesttfileviewView::OnUpdateToolsHideCompressed(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeFile.GetFileHideFlags() & FILE_ATTRIBUTE_COMPRESSED);
}

void CTesttfileviewView::OnToolsHideSystem()
{
  if (m_TreeFile.GetFileHideFlags() & FILE_ATTRIBUTE_SYSTEM)
    m_TreeFile.SetFileHideFlags(m_TreeFile.GetFileHideFlags() & ~FILE_ATTRIBUTE_SYSTEM);
  else
    m_TreeFile.SetFileHideFlags(m_TreeFile.GetFileHideFlags() | FILE_ATTRIBUTE_SYSTEM);
}

#pragma warning(suppress: 26429)
void CTesttfileviewView::OnUpdateToolsHideSystem(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeFile.GetFileHideFlags() & FILE_ATTRIBUTE_SYSTEM);
}

void CTesttfileviewView::OnToolsHideTemporary()
{
  if (m_TreeFile.GetFileHideFlags() & FILE_ATTRIBUTE_TEMPORARY)
    m_TreeFile.SetFileHideFlags(m_TreeFile.GetFileHideFlags() & ~FILE_ATTRIBUTE_TEMPORARY);
  else
    m_TreeFile.SetFileHideFlags(m_TreeFile.GetFileHideFlags() | FILE_ATTRIBUTE_TEMPORARY);
}

#pragma warning(suppress: 26429)
void CTesttfileviewView::OnUpdateToolsHideTemporary(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeFile.GetFileHideFlags() & FILE_ATTRIBUTE_TEMPORARY);
}

void CTesttfileviewView::OnToolsHideEncrypted()
{
  if (m_TreeFile.GetFileHideFlags() & FILE_ATTRIBUTE_ENCRYPTED)
    m_TreeFile.SetFileHideFlags(m_TreeFile.GetFileHideFlags() & ~FILE_ATTRIBUTE_ENCRYPTED);
  else
    m_TreeFile.SetFileHideFlags(m_TreeFile.GetFileHideFlags() | FILE_ATTRIBUTE_ENCRYPTED);
}

#pragma warning(suppress: 26429)
void CTesttfileviewView::OnUpdateToolsHideEncrypted(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeFile.GetFileHideFlags() & FILE_ATTRIBUTE_ENCRYPTED);
}

void CTesttfileviewView::OnToolsHideOffline()
{
  if (m_TreeFile.GetFileHideFlags() & FILE_ATTRIBUTE_OFFLINE)
    m_TreeFile.SetFileHideFlags(m_TreeFile.GetFileHideFlags() & ~FILE_ATTRIBUTE_OFFLINE);
  else
    m_TreeFile.SetFileHideFlags(m_TreeFile.GetFileHideFlags() | FILE_ATTRIBUTE_OFFLINE);
}

#pragma warning(suppress: 26429)
void CTesttfileviewView::OnUpdateToolsHideOffline(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeFile.GetFileHideFlags() & FILE_ATTRIBUTE_OFFLINE);
}

void CTesttfileviewView::OnToolsHideReadOnly()
{
  if (m_TreeFile.GetFileHideFlags() & FILE_ATTRIBUTE_READONLY)
    m_TreeFile.SetFileHideFlags(m_TreeFile.GetFileHideFlags() & ~FILE_ATTRIBUTE_READONLY);
  else
    m_TreeFile.SetFileHideFlags(m_TreeFile.GetFileHideFlags() | FILE_ATTRIBUTE_READONLY);
}

#pragma warning(suppress: 26429)
void CTesttfileviewView::OnUpdateToolsHideReadOnly(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeFile.GetFileHideFlags() & FILE_ATTRIBUTE_READONLY);
}

void CTesttfileviewView::OnToolsHideReparsePoint()
{
  if (m_TreeFile.GetFileHideFlags() & FILE_ATTRIBUTE_REPARSE_POINT)
    m_TreeFile.SetFileHideFlags(m_TreeFile.GetFileHideFlags() & ~FILE_ATTRIBUTE_REPARSE_POINT);
  else
    m_TreeFile.SetFileHideFlags(m_TreeFile.GetFileHideFlags() | FILE_ATTRIBUTE_REPARSE_POINT);
}

#pragma warning(suppress: 26429)
void CTesttfileviewView::OnUpdateToolsHideReparsePoint(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeFile.GetFileHideFlags() & FILE_ATTRIBUTE_REPARSE_POINT);
}

void CTesttfileviewView::OnToolsHideSparse()
{
  if (m_TreeFile.GetFileHideFlags() & FILE_ATTRIBUTE_SPARSE_FILE)
    m_TreeFile.SetFileHideFlags(m_TreeFile.GetFileHideFlags() & ~FILE_ATTRIBUTE_SPARSE_FILE);
  else
    m_TreeFile.SetFileHideFlags(m_TreeFile.GetFileHideFlags() | FILE_ATTRIBUTE_SPARSE_FILE);
}

#pragma warning(suppress: 26429)
void CTesttfileviewView::OnUpdateToolsHideSparse(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeFile.GetFileHideFlags() & FILE_ATTRIBUTE_SPARSE_FILE);
}

void CTesttfileviewView::OnToolsHideHidden2()
{
  if (m_TreeFile.GetFolderHideFlags() & FILE_ATTRIBUTE_HIDDEN)
    m_TreeFile.SetFolderHideFlags(m_TreeFile.GetFolderHideFlags() & ~FILE_ATTRIBUTE_HIDDEN);
  else
    m_TreeFile.SetFolderHideFlags(m_TreeFile.GetFolderHideFlags() | FILE_ATTRIBUTE_HIDDEN);
}

#pragma warning(suppress: 26429)
void CTesttfileviewView::OnUpdateToolsHideHidden2(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeFile.GetFolderHideFlags() & FILE_ATTRIBUTE_HIDDEN);
}

void CTesttfileviewView::OnToolsHideArchive2()
{
  if (m_TreeFile.GetFolderHideFlags() & FILE_ATTRIBUTE_ARCHIVE)
    m_TreeFile.SetFolderHideFlags(m_TreeFile.GetFolderHideFlags() & ~FILE_ATTRIBUTE_ARCHIVE);
  else
    m_TreeFile.SetFolderHideFlags(m_TreeFile.GetFolderHideFlags() | FILE_ATTRIBUTE_ARCHIVE);
}

#pragma warning(suppress: 26429)
void CTesttfileviewView::OnUpdateToolsHideArchive2(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeFile.GetFolderHideFlags() & FILE_ATTRIBUTE_ARCHIVE);
}

void CTesttfileviewView::OnToolsHideCompressed2()
{
  if (m_TreeFile.GetFolderHideFlags() & FILE_ATTRIBUTE_COMPRESSED)
    m_TreeFile.SetFolderHideFlags(m_TreeFile.GetFolderHideFlags() & ~FILE_ATTRIBUTE_COMPRESSED);
  else
    m_TreeFile.SetFolderHideFlags(m_TreeFile.GetFolderHideFlags() | FILE_ATTRIBUTE_COMPRESSED);
}

#pragma warning(suppress: 26429)
void CTesttfileviewView::OnUpdateToolsHideCompressed2(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeFile.GetFolderHideFlags() & FILE_ATTRIBUTE_COMPRESSED);
}

void CTesttfileviewView::OnToolsHideSystem2()
{
  if (m_TreeFile.GetFolderHideFlags() & FILE_ATTRIBUTE_SYSTEM)
    m_TreeFile.SetFolderHideFlags(m_TreeFile.GetFolderHideFlags() & ~FILE_ATTRIBUTE_SYSTEM);
  else
    m_TreeFile.SetFolderHideFlags(m_TreeFile.GetFolderHideFlags() | FILE_ATTRIBUTE_SYSTEM);
}

#pragma warning(suppress: 26429)
void CTesttfileviewView::OnUpdateToolsHideSystem2(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeFile.GetFolderHideFlags() & FILE_ATTRIBUTE_SYSTEM);
}

void CTesttfileviewView::OnToolsHideTemporary2()
{
  if (m_TreeFile.GetFolderHideFlags() & FILE_ATTRIBUTE_TEMPORARY)
    m_TreeFile.SetFolderHideFlags(m_TreeFile.GetFolderHideFlags() & ~FILE_ATTRIBUTE_TEMPORARY);
  else
    m_TreeFile.SetFolderHideFlags(m_TreeFile.GetFolderHideFlags() | FILE_ATTRIBUTE_TEMPORARY);
}

#pragma warning(suppress: 26429)
void CTesttfileviewView::OnUpdateToolsHideTemporary2(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeFile.GetFolderHideFlags() & FILE_ATTRIBUTE_TEMPORARY);
}

void CTesttfileviewView::OnToolsHideEncrypted2()
{
  if (m_TreeFile.GetFolderHideFlags() & FILE_ATTRIBUTE_ENCRYPTED)
    m_TreeFile.SetFolderHideFlags(m_TreeFile.GetFolderHideFlags() & ~FILE_ATTRIBUTE_ENCRYPTED);
  else
    m_TreeFile.SetFolderHideFlags(m_TreeFile.GetFolderHideFlags() | FILE_ATTRIBUTE_ENCRYPTED);
}

#pragma warning(suppress: 26429)
void CTesttfileviewView::OnUpdateToolsHideEncrypted2(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeFile.GetFolderHideFlags() & FILE_ATTRIBUTE_ENCRYPTED);
}

void CTesttfileviewView::OnToolsHideOffline2()
{
  if (m_TreeFile.GetFolderHideFlags() & FILE_ATTRIBUTE_OFFLINE)
    m_TreeFile.SetFolderHideFlags(m_TreeFile.GetFolderHideFlags() & ~FILE_ATTRIBUTE_OFFLINE);
  else
    m_TreeFile.SetFolderHideFlags(m_TreeFile.GetFolderHideFlags() | FILE_ATTRIBUTE_OFFLINE);
}

#pragma warning(suppress: 26429)
void CTesttfileviewView::OnUpdateToolsHideOffline2(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeFile.GetFolderHideFlags() & FILE_ATTRIBUTE_OFFLINE);
}

#pragma warning(suppress: 26429)
void CTesttfileviewView::OnToolsHideReadOnly2()
{
  if (m_TreeFile.GetFolderHideFlags() & FILE_ATTRIBUTE_READONLY)
    m_TreeFile.SetFolderHideFlags(m_TreeFile.GetFolderHideFlags() & ~FILE_ATTRIBUTE_READONLY);
  else
    m_TreeFile.SetFolderHideFlags(m_TreeFile.GetFolderHideFlags() | FILE_ATTRIBUTE_READONLY);
}

#pragma warning(suppress: 26429)
void CTesttfileviewView::OnUpdateToolsHideReadOnly2(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeFile.GetFolderHideFlags() & FILE_ATTRIBUTE_READONLY);
}


void CTesttfileviewView::OnToolsHideReparsePoint2()
{
  if (m_TreeFile.GetFolderHideFlags() & FILE_ATTRIBUTE_REPARSE_POINT)
    m_TreeFile.SetFolderHideFlags(m_TreeFile.GetFolderHideFlags() & ~FILE_ATTRIBUTE_REPARSE_POINT);
  else
    m_TreeFile.SetFolderHideFlags(m_TreeFile.GetFolderHideFlags() | FILE_ATTRIBUTE_REPARSE_POINT);
}

#pragma warning(suppress: 26429)
void CTesttfileviewView::OnUpdateToolsHideReparsePoint2(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeFile.GetFolderHideFlags() & FILE_ATTRIBUTE_REPARSE_POINT);
}

void CTesttfileviewView::OnToolsHideSparse2()
{
  if (m_TreeFile.GetFolderHideFlags() & FILE_ATTRIBUTE_SPARSE_FILE)
    m_TreeFile.SetFolderHideFlags(m_TreeFile.GetFolderHideFlags() & ~FILE_ATTRIBUTE_SPARSE_FILE);
  else
    m_TreeFile.SetFolderHideFlags(m_TreeFile.GetFolderHideFlags() | FILE_ATTRIBUTE_SPARSE_FILE);
}

#pragma warning(suppress: 26429)
void CTesttfileviewView::OnUpdateToolsHideSparse2(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeFile.GetFolderHideFlags() & FILE_ATTRIBUTE_SPARSE_FILE);
}

void CTesttfileviewView::OnToolsAutoRefresh()
{
  m_TreeFile.SetAutoRefresh(!m_TreeFile.GetAutoRefresh());
}

#pragma warning(suppress: 26429)
void CTesttfileviewView::OnUpdateToolsAutoRefresh(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeFile.GetAutoRefresh());
}

void CTesttfileviewView::OnToolsHideNetwork()
{
  m_TreeFile.SetShowNetwork(!m_TreeFile.GetShowNetwork());
}

#pragma warning(suppress: 26429)
void CTesttfileviewView::OnUpdateToolsHideNetwork(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(!m_TreeFile.GetShowNetwork());
}

void CTesttfileviewView::OnToolsShowSharedFolders()
{
  m_TreeFile.SetUsingDifferentIconForSharedFolders(!m_TreeFile.GetUsingDifferentIconForSharedFolders());
}

#pragma warning(suppress: 26429)
void CTesttfileviewView::OnUpdateToolsShowSharedFolders(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeFile.GetUsingDifferentIconForSharedFolders());
}

void CTesttfileviewView::OnToolsSetRootFolder()
{
  CRootFolderDlg dlg;
  dlg.m_sFolder = m_TreeFile.GetRootFolder();
  if (dlg.DoModal() == IDOK)
    m_TreeFile.SetRootFolder(dlg.m_sFolder);
}

#pragma warning(suppress: 26434)
void CTesttfileviewView::OnDestroy()
{
  //Remember the selected path, ready for the next time around
  CString sSelPath(m_TreeFile.GetSelectedPath());
  CWinApp* pApp = AfxGetApp();
#pragma warning(suppress: 26496)
  AFXASSUME(pApp != nullptr);
  pApp->WriteProfileString(_T("Settings"), _T("Last Path"), sSelPath);
  const BOOL bExpanded = m_TreeFile.IsExpanded(m_TreeFile.PathToItem(sSelPath));
  pApp->WriteProfileInt(_T("Settings"), _T("Expanded"), bExpanded);

  //Let the parent class do its thing
  __super::OnDestroy();
}

void CTesttfileviewView::OnToolsShowAllNetworkItems()
{
  m_TreeFile.SetNetworkItemTypes(RESOURCETYPE_ANY);
}

#pragma warning(suppress: 26429)
void CTesttfileviewView::OnUpdateToolsShowAllNetworkItems(CCmdUI* pCmdUI)
{
  const DWORD dwTypes = m_TreeFile.GetNetworkItemTypes();
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(dwTypes == RESOURCETYPE_ANY);
}

void CTesttfileviewView::OnToolsShowNetworkPrinters()
{
  m_TreeFile.SetNetworkItemTypes(RESOURCETYPE_PRINT);
}

#pragma warning(suppress: 26429)
void CTesttfileviewView::OnUpdateToolsShowNetworkPrinters(CCmdUI* pCmdUI)
{
  const DWORD dwTypes = m_TreeFile.GetNetworkItemTypes();
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(dwTypes == RESOURCETYPE_PRINT);
}

void CTesttfileviewView::OnToolsShowNetworkShares()
{
  m_TreeFile.SetNetworkItemTypes(RESOURCETYPE_DISK);
}

#pragma warning(suppress: 26429)
void CTesttfileviewView::OnUpdateToolsShowNetworkShares(CCmdUI* pCmdUI)
{
  const DWORD dwTypes = m_TreeFile.GetNetworkItemTypes();
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(dwTypes & RESOURCETYPE_DISK);
}

void CTesttfileviewView::OnToolsShowDriveLabels()
{
  m_TreeFile.SetShowDriveLabels(!m_TreeFile.GetShowDriveLabels());
}

#pragma warning(suppress: 26429)
void CTesttfileviewView::OnUpdateToolsShowDriveLabels(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeFile.GetShowDriveLabels());
}

void CTesttfileviewView::OnToolsHideMyComputer()
{
  m_TreeFile.SetShowMyComputer(!m_TreeFile.GetShowMyComputer());
}

#pragma warning(suppress: 26429)
void CTesttfileviewView::OnUpdateToolsHideMyComputer(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(!m_TreeFile.GetShowMyComputer());
}

void CTesttfileviewView::OnToolsShowRootedFolder()
{
  m_TreeFile.SetShowRootedFolder(!m_TreeFile.GetShowRootedFolder());
}

#pragma warning(suppress: 26429)
void CTesttfileviewView::OnUpdateToolsShowRootedFolder(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeFile.GetShowRootedFolder());
}

void CTesttfileviewView::OnToolsSetSelectedPath()
{
  CSelectedPathDlg dlg;
  dlg.m_sPath = m_TreeFile.GetSelectedPath();
  if (dlg.DoModal() == IDOK)
  {
    HTREEITEM hItemFound = m_TreeFile.SetSelectedPath(dlg.m_sPath, dlg.m_bExpand);
    if (hItemFound)
      m_TreeFile.EnsureVisible(hItemFound);
  }
}

void CTesttfileviewView::OnToolsHideDesktop()
{
  m_TreeFile.SetShowDesktop(!m_TreeFile.GetShowDesktop());
}

#pragma warning(suppress: 26429)
void CTesttfileviewView::OnUpdateToolsHideDesktop(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(!m_TreeFile.GetShowDesktop());
}

void CTesttfileviewView::OnToolsHideMyDocuments()
{
  m_TreeFile.SetShowMyDocuments(!m_TreeFile.GetShowMyDocuments());
}

#pragma warning(suppress: 26429)
void CTesttfileviewView::OnUpdateToolsHideMyDocuments(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(!m_TreeFile.GetShowMyDocuments());
}

void CTesttfileviewView::OnToolsHideCurrentUserFolder()
{
  m_TreeFile.SetShowCurrentUserFolder(!m_TreeFile.GetShowCurrentUserFolder());
}

#pragma warning(suppress: 26429)
void CTesttfileviewView::OnUpdateToolsHideCurrentUserFolder(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(!m_TreeFile.GetShowCurrentUserFolder());
}
